import java.util.Random;

public class Poisson
{
  private int lambda;
  private double values[];
  
  public Poisson(int lambda)
  {
    this.lambda = lambda;
    this.values = new double [3 * lambda];
    
    this.values[0] = functionOfKAndLambda(0);
    for (int i = 1; i < values.length; i++) 
      this.values[i] = this.values[i-1] + functionOfKAndLambda(i);
  }
  
  private double functionOfKAndLambda(int k)
  {
    return Math.pow(lambda, k) * Math.pow(Math.E, -lambda) / factorial(k);
  }
  
  private long factorial(long n)
  {
    long factorial = 1;
    
    // write the code for a loop to calculate factorial of n here
    for (long i = 2; i <= n; i++)
     factorial = i * factorial;
    
    return factorial;
  }
  
  public int getValue()
  {
    double random = Math.random();
    for (int i = 0; i < values.length; i++)
      if (random < values[i])
        return i;
    return values.length; 
  }
  
  // test case code for the Poisson distribution code
  public static void main(String [] args)
  {
    final int lambda = 4;                   // average value of distribution
    
    int [] myArray = new int[3*lambda + 1];
    for (int i = 0; i < myArray.length; i++)
      myArray[i] = 0;
    
    Poisson myDist = new Poisson(lambda);
    for (int i = 0; i < 20000; i++)
      myArray[myDist.getValue()]++;
 
    Histogram myHistogram = new Histogram(myArray, 0, 3*lambda, 13);
    myHistogram.drawHor();
    /* good values for lambda = 4
     * Value 0: * 1 
     * Value 1: ******* 7 
     * Value 2: ************** 14 
     * Value 3: ******************* 19 
     * Value 4: ******************** 20 
     * Value 5: **************** 16 
     * Value 6: ********** 10 
     * Value 7: ****** 6 
     * Value 8: ** 2 
     * Value 9: * 1 
     * Value 10:  0 
     * Value 11:  0 
     * Value 12:  0 
     */
  }
}